<script lang="ts">
  import logo from '$lib/assets/images/ncae_cybergames_logo.png';
  // import { clickOutside } from '$lib/directives/click-outside';
  import { fly } from 'svelte/transition';
  import { isAuthenticated, oidcClient, authTokenParsed } from '$stores/authStore';
  import navTabs, { shouldDisplay } from './data/nav-tabs';
  import MobileNavbarTab from './MobileNavbarTab.svelte';
  import NavbarTab from './NavbarTab.svelte';
  import discordLogo from '$lib/assets/images/discord.svg';
  import { discordInvite } from '$lib/constants/urls';
  import { Button } from "flowbite-svelte";

  let mobileNavbarIsOpen = false;

  const toggleMobileNavbar = () => {
    mobileNavbarIsOpen = !mobileNavbarIsOpen;
  };

  // const handleClickOutside = () => {
  //   mobileNavbarIsOpen = false;
  // };
</script>

<!-- Desktop -->
<header class="hidden xl:block sticky top-0 z-50">
  <nav class="flex justify-between bg-cyber-gray-100 px-5 h-15">
    <div class="flex flex-col flex-shrink-0 justify-center py-4 mr-4">
      <a href="/"><img src={logo} alt="brand" class="h-12" /></a>
    </div>
    <div class="w-full">
      <ul class="h-full flex justify-between items-center xl:mx-5">
        <!-- Dropdown Tabs -->
        {#key $authTokenParsed}
          {#each navTabs as tab}
            {#if shouldDisplay(tab, $isAuthenticated, $authTokenParsed)}
              <NavbarTab navTab={tab} />
            {/if}
          {/each}
        {/key}
      </ul>
    </div>
    <!-- Login / Logout -->
    <div class="flex items-center py-4">
      <Button
        data-umami-event="Discord Invite"
        color="none"
        class="flex items-center text-center mr-4"
        href={discordInvite}
        target="_blank"
      >
        <h1 class="font-bold text-cyber-blue-900">Join our Discord!</h1>
        <img class="w-2/3 px-4 pb-2 h-11" src={discordLogo} alt="Discord Logo" />
      </Button>
      {#if $isAuthenticated}
        <Button
          data-umami-event="Logout"
          class="border py-2 uppercase bg-red-600 hover:bg-red-500 text-cyber-gray-100 font-semibold text-lg rounded-xl h-11 w-40"
          on:click={() => $oidcClient.logout()}>Logout</Button>
      {:else}
        <Button
          data-umami-event="Login"
          id="login-button"
          class="border py-2 uppercase bg-cyber-blue-900 hover:bg-cyber-blue-800 text-cyber-gray-100 font-semibold text-lg rounded-xl h-11 w-40"
          on:click={() => $oidcClient.login()}>Login</Button>
      {/if}
    </div>
  </nav>
</header>

<!-- Mobile -->
<!-- todo reimplement use:clickOutside on:click_outside={handleClickOutside} -->
<header class="xl:hidden sticky top-0 z-50" >
  <div class="flex h-16 justify-between items-center bg-cyber-gray-100 px-4 z-20">
    <div class="py-4 mr-4 flex-shrink-0">
      <a href="/"><img src={logo} alt="brand" class="h-12" /></a>
    </div>
    <div class="flex gap-2">
      <Button
        color="none"
        data-umami-event="Discord Invite"
        class="flex flex-row-reverse gap-2 items-center text-center"
        href={discordInvite}
        target="_blank"
      >
        <img class="h-1/2" src={discordLogo} alt="Discord Logo" />
        <h1 class="hidden sm:block font-bold text-sm text-cyber-blue-900">Join our Discord!</h1>
      </Button>
      {#if $isAuthenticated}
        <Button
          data-umami-event="Logout"
          class="border my-2 py-2 px-2 uppercase bg-red-600 hover:bg-red-500 text-cyber-gray-100 font-semibold rounded-xl"
          on:click={() => $oidcClient.logout()}>Logout</Button>
      {:else}
        <Button
          data-umami-event="Login"
          id="login-button"
          class="border my-2 py-2 px-2 uppercase bg-cyber-blue-900 hover:bg-cyber-blue-800 text-cyber-gray-100 font-semibold rounded-xl"
          on:click={() => $oidcClient.login()}>Login</Button>
      {/if}
      <button on:click={toggleMobileNavbar}>
        {#if mobileNavbarIsOpen}
          <svg
            xmlns="http://www.w3.org/2000/svg"
            class="h-6 w-6"
            fill="none"
            viewBox="0 0 24 24"
            stroke="currentColor"
            stroke-width="2">
            <path stroke-linecap="round" stroke-linejoin="round" d="M6 18L18 6M6 6l12 12" />
          </svg>
        {:else}
          <svg
            xmlns="http://www.w3.org/2000/svg"
            class="h-6 w-6"
            fill="none"
            viewBox="0 0 24 24"
            stroke="black"
            stroke-width="2">
            <path stroke-linecap="round" stroke-linejoin="round" d="M4 6h16M4 12h16M4 18h16" />
          </svg>
        {/if}
      </button>
    </div>
  </div>
  {#if mobileNavbarIsOpen}
    <nav class="absolute bg-cyber-gray-100 w-full z-10 border-b-2" transition:fly={{ x: -200, duration: 500 }}>
      <ul class="max-h-dvh-80 flex flex-col overflow-y-scroll">
        <!-- Dropdown Tabs -->
        {#key $authTokenParsed}
          {#each navTabs as tab}
            {#if shouldDisplay(tab, $isAuthenticated, $authTokenParsed)}
              <MobileNavbarTab navTab={tab} on:click={toggleMobileNavbar} />
            {/if}
          {/each}
        {/key}
      </ul>
    </nav>
  {/if}
</header>

<style type="text/css">
  .max-h-dvh-80 {
    max-height: 80dvh;
  }
</style>